# ifndef FLUOROETHENE_H
# define FLUOROETHENE_H

/* 剣師関係 */

/* 剣技表現配列サイズ */
#define SWORD_SIZE 16
/* Kenshi#stateの値 */
#define SS_ACTIVE 0
#define SS_SLEEP  1
#define SS_USED   2
#define SS_LOST   3

typedef struct {
	int hp, attack, defense, speed;
	int max_hp;
	int swords[SWORD_SIZE]; /* 剣番号で剣の並びを表現。-1が終端記号。 */
	int state[SWORD_SIZE]; /* 剣状態。0:使用可能，1:未起動，2:使用済み，3:リミテッド消滅済み。 */
	int poison, stun, guard, reflection, life, heavy_push;
	int ap;
} Kenshi;

void ken_init(Kenshi *self, int hp, int atk, int dfs, int spd, const int *swd);
void ken_cpy(const Kenshi *src, Kenshi *dest);
void ken_to_theki(const Kenshi *self, char *dest);
void ken_add_theki(const Kenshi *self, char *filename);
void ken_read_theki(Kenshi *self, const char *str);
void ken_set_ap(Kenshi *self, int turn);
int ken_aizawa(Kenshi *self);
int ken_oranda(Kenshi *self);
void ken_each_in(int toshin, void (*proc)(Kenshi *self), int dly);

/* 剣関係 */

/* 剣総種類数 */
#define SWORD_VARIATION 56
/* 剣種別番号 */
#define SC_ATTACK 0
#define SC_STATUS 1

typedef struct {
	const char *name;
	int category, awake, limited;
	void (*body)(Kenshi *controller, Kenshi *target);
} Sword;

int read_sword(const char **str);

extern const Sword SwordList[];

# define S_SLASH 0
# define S_RAPID 1
# define S_HEAVY 2
# define S_SHOCK 3
# define S_POISON 4
# define S_ABSOLUTE 5
# define S_MAGICAL 6
# define S_DEATH 7
# define S_HEAT 8
# define S_PROTECTION 9
# define S_ACCEL 10
# define S_SHIELD 11
# define S_MIRROR 12
# define S_LIFE 13
# define S_RECOVERY(i) (13+(i))
# define IS_RECOVERY(s) ((s)>=S_RECOVERY(1)&&(s)<=S_RECOVERY(21))
# define S_VICTORY(i) (S_RECOVERY(21)+i)
# define S_MAX S_VICTORY(21)

/* 戦闘データ関係 */

/* 死亡判定・ターン進行時の結果値 */
#define CONTINUE 0
#define C1_WIN   1
#define C2_WIN   2
#define DRAW     3

int bd_go(Kenshi *c1_org, Kenshi *c2_org);
int bd_go_by_cpy(const Kenshi *c1_org, const Kenshi *c2_org);

# endif
